Index: /branches/OKB (trunk integration)/HeuristicLab.Clients.OKB/3.3/HeuristicLab.Clients.OKB-3.3.csproj
===================================================================
--- /branches/OKB (trunk integration)/HeuristicLab.Clients.OKB/3.3/HeuristicLab.Clients.OKB-3.3.csproj	(revision 5303)
+++ /branches/OKB (trunk integration)/HeuristicLab.Clients.OKB/3.3/HeuristicLab.Clients.OKB-3.3.csproj	(revision 5304)
@@ -108,9 +108,8 @@
     <Compile Include="ServiceClients\AlgorithmData.cs" />
     <Compile Include="ServiceClients\AlgorithmParameter.cs" />
-    <Compile Include="ServiceClients\AndFilter.cs" />
+    <Compile Include="ServiceClients\CombinedFilter.cs" />
     <Compile Include="ServiceClients\OKBServiceClients.cs" />
     <Compile Include="ServiceClients\SetComparisonStringAvailableValuesFilter.cs" />
     <Compile Include="ServiceClients\NameSetComparisonStringAvailableValuesFilter.cs" />
-    <Compile Include="ServiceClients\OrFilter.cs" />
     <Compile Include="ServiceClients\OrdinalComparisonDateTimeFilter.cs" />
     <Compile Include="ServiceClients\OrdinalComparisonLongFilter.cs" />
@@ -183,10 +182,4 @@
       <DependentUpon>AlgorithmParameterView.cs</DependentUpon>
     </Compile>
-    <Compile Include="Views\AndFilterView.cs">
-      <SubType>UserControl</SubType>
-    </Compile>
-    <Compile Include="Views\AndFilterView.Designer.cs">
-      <DependentUpon>AndFilterView.cs</DependentUpon>
-    </Compile>
     <Compile Include="Views\SetComparisonStringAvailableValuesFilterView.cs">
       <SubType>UserControl</SubType>
@@ -200,10 +193,4 @@
     <Compile Include="Views\NameSetComparisonStringAvailableValuesFilterView.Designer.cs">
       <DependentUpon>NameSetComparisonStringAvailableValuesFilterView.cs</DependentUpon>
-    </Compile>
-    <Compile Include="Views\OrFilterView.cs">
-      <SubType>UserControl</SubType>
-    </Compile>
-    <Compile Include="Views\OrFilterView.Designer.cs">
-      <DependentUpon>OrFilterView.cs</DependentUpon>
     </Compile>
     <Compile Include="Views\CombinedFilterView.cs">
Index: /branches/OKB (trunk integration)/HeuristicLab.Clients.OKB/3.3/OKBClient.cs
===================================================================
--- /branches/OKB (trunk integration)/HeuristicLab.Clients.OKB/3.3/OKBClient.cs	(revision 5303)
+++ /branches/OKB (trunk integration)/HeuristicLab.Clients.OKB/3.3/OKBClient.cs	(revision 5304)
@@ -603,86 +603,4 @@
       }
     }
-    public RunCollection ConvertOKBRunsToOptimizationRuns(IItemCollection<Run> runs) {
-      RunCollection runCollection = new RunCollection();
-      foreach (Run run in runs) {
-        Optimization.Run r = new Optimization.Run();
-        foreach (ResultValue resultValue in run.ResultValues) {
-          Result result = GetResult(resultValue.ResultId);
-          if (resultValue is ResultBlobValue) {
-            IItem item = null;
-            using (MemoryStream stream = new MemoryStream(((ResultBlobValue)resultValue).Value)) {
-              try {
-                item = XmlParser.Deserialize<IItem>(stream);
-              }
-              catch (Exception ex) {
-                ErrorHandling.ShowErrorDialog(ex);
-              }
-              stream.Close();
-            }
-            r.Results.Add(result.Name, item);
-          } else if (resultValue is ResultBoolValue) {
-            r.Results.Add(result.Name, new BoolValue(((ResultBoolValue)resultValue).Value));
-          } else if (resultValue is ResultFloatValue) {
-            r.Results.Add(result.Name, new DoubleValue(((ResultFloatValue)resultValue).Value));
-          } else if (resultValue is ResultIntValue) {
-            r.Results.Add(result.Name, new IntValue((int)((ResultIntValue)resultValue).Value));
-          } else if (resultValue is ResultStringValue) {
-            r.Results.Add(result.Name, new StringValue(((ResultStringValue)resultValue).Value));
-          }
-        }
-
-        Experiment exp = GetExperiment(run.ExperimentId);
-        foreach (AlgorithmParameterValue algorithmParameterValue in exp.AlgorithmParameterValues) {
-          AlgorithmParameter algorithmParameter = GetAlgorithmParameter(algorithmParameterValue.AlgorithmParameterId);
-          if (algorithmParameterValue is AlgorithmParameterBlobValue) {
-            IItem item = null;
-            using (MemoryStream stream = new MemoryStream(((AlgorithmParameterBlobValue)algorithmParameterValue).Value)) {
-              try {
-                item = XmlParser.Deserialize<IItem>(stream);
-              }
-              catch (Exception ex) {
-                ErrorHandling.ShowErrorDialog(ex);
-              }
-              stream.Close();
-            }
-            r.Parameters.Add(algorithmParameter.Name, item);
-          } else if (algorithmParameterValue is AlgorithmParameterBoolValue) {
-            r.Parameters.Add(algorithmParameter.Name, new BoolValue(((AlgorithmParameterBoolValue)algorithmParameterValue).Value));
-          } else if (algorithmParameterValue is AlgorithmParameterFloatValue) {
-            r.Parameters.Add(algorithmParameter.Name, new DoubleValue(((AlgorithmParameterFloatValue)algorithmParameterValue).Value));
-          } else if (algorithmParameterValue is AlgorithmParameterIntValue) {
-            r.Parameters.Add(algorithmParameter.Name, new IntValue((int)((AlgorithmParameterIntValue)algorithmParameterValue).Value));
-          } else if (algorithmParameterValue is AlgorithmParameterStringValue) {
-            r.Parameters.Add(algorithmParameter.Name, new StringValue(((AlgorithmParameterStringValue)algorithmParameterValue).Value));
-          }
-        }
-        foreach (ProblemParameterValue problemParameterValue in exp.ProblemParameterValues) {
-          ProblemParameter problemParameter = GetProblemParameter(problemParameterValue.ProblemParameterId);
-          if (problemParameterValue is ProblemParameterBlobValue) {
-            IItem item = null;
-            using (MemoryStream stream = new MemoryStream(((ProblemParameterBlobValue)problemParameterValue).Value)) {
-              try {
-                item = XmlParser.Deserialize<IItem>(stream);
-              }
-              catch (Exception ex) {
-                ErrorHandling.ShowErrorDialog(ex);
-              }
-              stream.Close();
-            }
-            r.Parameters.Add(problemParameter.Name, item);
-          } else if (problemParameterValue is ProblemParameterBoolValue) {
-            r.Parameters.Add(problemParameter.Name, new BoolValue(((ProblemParameterBoolValue)problemParameterValue).Value));
-          } else if (problemParameterValue is ProblemParameterFloatValue) {
-            r.Parameters.Add(problemParameter.Name, new DoubleValue(((ProblemParameterFloatValue)problemParameterValue).Value));
-          } else if (problemParameterValue is ProblemParameterIntValue) {
-            r.Parameters.Add(problemParameter.Name, new IntValue((int)((ProblemParameterIntValue)problemParameterValue).Value));
-          } else if (problemParameterValue is ProblemParameterStringValue) {
-            r.Parameters.Add(problemParameter.Name, new StringValue(((ProblemParameterStringValue)problemParameterValue).Value));
-          }
-        }
-        runCollection.Add(r);
-      }
-      return runCollection;
-    }
     #endregion
 
@@ -695,6 +613,6 @@
         }
         catch (Exception ex) {
-          ErrorHandling.ShowErrorDialog("Refresh filters.", ex);
-          return null;
+          ErrorHandling.ShowErrorDialog("Get filters failed.", ex);
+          return Enumerable.Empty<Filter>();
         }
       }
@@ -704,21 +622,28 @@
       return GetFilters(false);
     }
-    public long QueryNumberOfRuns(Filter filter) {
-      try {
-        return CallQueryService<long>(x => x.QueryNumberOfRuns(filter));
-      }
-      catch (Exception ex) {
-        ErrorHandling.ShowErrorDialog("Refresh runs failed.", ex);
+    public long GetNumberOfQueryResults(Filter filter) {
+      try {
+        return CallQueryService<long>(x => x.GetNumberOfQueryResults(filter));
+      }
+      catch (Exception ex) {
+        ErrorHandling.ShowErrorDialog("Get number of query results failed.", ex);
         return -1;
       }
     }
-    public ItemCollection<Run> QueryRuns(Filter filter) {
-      try {
-        ItemCollection<Run> runs = new ItemCollection<Run>();
-        runs.AddRange(CallQueryService<List<Run>>(s => s.QueryRuns(filter)).OrderByDescending(x => x.CreatedDate));
-        return runs;
-      }
-      catch (Exception ex) {
-        ErrorHandling.ShowErrorDialog("Refresh runs failed.", ex);
+    public IEnumerable<long> GetQueryResultIds(Filter filter) {
+      try {
+        return CallQueryService<IEnumerable<long>>(x => x.GetQueryResultIds(filter));
+      }
+      catch (Exception ex) {
+        ErrorHandling.ShowErrorDialog("Get query result ids failed.", ex);
+        return Enumerable.Empty<long>();
+      }
+    }
+    public IEnumerable<QueryResult> GetQueryResults(IEnumerable<long> ids) {
+      try {
+        return CallQueryService<IEnumerable<QueryResult>>(s => s.GetQueryResults(ids.ToList()));
+      }
+      catch (Exception ex) {
+        ErrorHandling.ShowErrorDialog("Get query results failed.", ex);
         return null;
       }
Index: /branches/OKB (trunk integration)/HeuristicLab.Clients.OKB/3.3/OKBExperiment.cs
===================================================================
--- /branches/OKB (trunk integration)/HeuristicLab.Clients.OKB/3.3/OKBExperiment.cs	(revision 5303)
+++ /branches/OKB (trunk integration)/HeuristicLab.Clients.OKB/3.3/OKBExperiment.cs	(revision 5304)
@@ -118,31 +118,34 @@
       }
     }
+    private RunCollection runs;
     public RunCollection Runs {
-      get {
-        if (Algorithm != null) return Algorithm.Runs;
-        else return null;
-      }
+      get { return runs; }
     }
 
     #region Persistence Properties
     [Storable(Name = "AlgorithmId")]
-    private long AlgorithmIdPersistence {
+    private long StorableAlgorithmId {
       get { return algorithmId; }
       set { algorithmId = value; }
     }
     [Storable(Name = "Algorithm")]
-    private IAlgorithm AlgorithmPersistence {
+    private IAlgorithm StorableAlgorithm {
       get { return Algorithm; }
       set { Algorithm = value; }
     }
     [Storable(Name = "ProblemId")]
-    private long ProblemIdPersistence {
+    private long StorableProblemId {
       get { return problemId; }
       set { problemId = value; }
     }
     [Storable(Name = "Problem")]
-    private IProblem ProblemPersistence {
+    private IProblem StorableProblem {
       get { return Problem; }
       set { Problem = value; }
+    }
+    [Storable(Name = "Runs")]
+    private RunCollection StorableRuns {
+      get { return runs; }
+      set { runs = value; }
     }
     #endregion
@@ -156,4 +159,5 @@
       problemId = original.problemId;
       problem = cloner.Clone(original.problem);
+      runs = cloner.Clone(original.runs);
       RegisterAlgorithmEvents();
     }
@@ -162,4 +166,5 @@
       name = ItemName;
       description = ItemDescription;
+      runs = new RunCollection();
     }
 
@@ -290,4 +295,7 @@
         Algorithm.Started += new EventHandler(algorithm_Started);
         Algorithm.Stopped += new EventHandler(algorithm_Stopped);
+        Algorithm.Runs.ItemsAdded += new Collections.CollectionItemsChangedEventHandler<IRun>(algorithm_Runs_ItemsAdded);
+        Algorithm.Runs.ItemsRemoved += new Collections.CollectionItemsChangedEventHandler<IRun>(algorithm_Runs_ItemsRemoved);
+        Algorithm.Runs.CollectionReset += new Collections.CollectionItemsChangedEventHandler<IRun>(algorithm_Runs_CollectionReset);
       }
     }
@@ -302,4 +310,7 @@
         Algorithm.Started -= new EventHandler(algorithm_Started);
         Algorithm.Stopped -= new EventHandler(algorithm_Stopped);
+        Algorithm.Runs.ItemsAdded -= new Collections.CollectionItemsChangedEventHandler<IRun>(algorithm_Runs_ItemsAdded);
+        Algorithm.Runs.ItemsRemoved -= new Collections.CollectionItemsChangedEventHandler<IRun>(algorithm_Runs_ItemsRemoved);
+        Algorithm.Runs.CollectionReset -= new Collections.CollectionItemsChangedEventHandler<IRun>(algorithm_Runs_CollectionReset);
       }
     }
@@ -334,4 +345,14 @@
         OnExceptionOccurred(ex);
       }
+    }
+    private void algorithm_Runs_ItemsAdded(object sender, Collections.CollectionItemsChangedEventArgs<IRun> e) {
+      runs.AddRange(e.Items);
+    }
+    private void algorithm_Runs_ItemsRemoved(object sender, Collections.CollectionItemsChangedEventArgs<IRun> e) {
+      runs.RemoveRange(e.Items);
+    }
+    private void algorithm_Runs_CollectionReset(object sender, Collections.CollectionItemsChangedEventArgs<IRun> e) {
+      runs.Clear();
+      runs.AddRange(algorithm.Runs);
     }
     #endregion
Index: /branches/OKB (trunk integration)/HeuristicLab.Clients.OKB/3.3/ServiceClients/CombinedFilter.cs
===================================================================
--- /branches/OKB (trunk integration)/HeuristicLab.Clients.OKB/3.3/ServiceClients/CombinedFilter.cs	(revision 5304)
+++ /branches/OKB (trunk integration)/HeuristicLab.Clients.OKB/3.3/ServiceClients/CombinedFilter.cs	(revision 5304)
@@ -0,0 +1,30 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Linq;
+
+namespace HeuristicLab.Clients.OKB {
+  public partial class CombinedFilter {
+    public override Filter Clone() {
+      return new CombinedFilter() { FilterTypeName = FilterTypeName, Label = Label, Operation = Operation, Filters = Filters.Select(x => x.Clone()).ToList() };
+    }
+  }
+}
